/* $Id: crires_wlcalib.h,v 1.20 2012-09-25 07:04:34 yjung Exp $
 *
 * This file is part of the CRIRES Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
 * $Author: yjung $
 * $Date: 2012-09-25 07:04:34 $
 * $Revision: 1.20 $
 * $Name: not supported by cvs2svn $
 */

#ifndef CRIRES_WLCALIB_H
#define CRIRES_WLCALIB_H

/*-----------------------------------------------------------------------------
                                Include
 -----------------------------------------------------------------------------*/

#include "crires_utils.h"

/*-----------------------------------------------------------------------------
                                Functions prototypes
 -----------------------------------------------------------------------------*/

cpl_table * crires_wlcalib_lamp(const char *, crires_illum_period, 
        const char *, int, const char *, const char *, const char *, 
        const char *, double, double, double, double, int, cpl_vector *, int, 
        int, double, double, double, int, int, double, int, int, double *, 
        double *, double *) ;

cpl_table * crires_wlcalib_sky(const char *, crires_illum_period, 
        const char *, const char *, int, const char *, const char *, 
        const char *, const char *, double, double, double, double, int,  
        cpl_vector *, int, int, double, double, double, int, int, double, int, 
        int) ;

cpl_polynomial * crires_wlcalib_engine(const cpl_vector *, 
        const cpl_bivector *, const cpl_polynomial *, double, double, int, 
        double, double, double, int, int, double, int, int, int, int, double *,
        cpl_table **) ;

cpl_imagelist * crires_wlcalib_gen_wlmap(const cpl_table **) ;

cpl_table * crires_wlcalib_gen_wltab_one(const cpl_polynomial *, int, double); 
cpl_table * crires_wlcalib_gen_wltab_several(const cpl_polynomial **,
        const cpl_vector *, const double *) ;
double crires_wlcalib_get_better_xc(const cpl_table *) ;
cpl_image * crires_wlcalib_gen_wlmap_one_chip(const cpl_table *) ;
cpl_vector * crires_wlcalib_detect_wave_ypos(const char *, 
        crires_illum_period, int) ;

#endif
